// intutils.h
// utilities built on sint.h for SafeTP
// copyright SafeTP Development Group, Inc., 2000  Terms of use are as specified in license.txt

#ifndef __INTUTILS_H
#define __INTUTILS_H

#include "sint.h"       // Integer
#include "cryptlib.h"   // RandomNumberGenerator


class RNG_Wrapper : public Integer::RandomSource {
  RandomNumberGenerator &rng;
public:
  RNG_Wrapper(RandomNumberGenerator &r) : rng(r) {}
  void getRandomBytes(unsigned char *dest, int numBytes)
    { rng.GetBlock(dest, numBytes); }
};


// assist with translation from Wei Dai's Integer class
inline Integer a_exp_b_mod_c(Integer const &a, Integer const &b,
                             Integer const &c)
{
  return a.expMod(b, c);
}


Integer pickRandom(RandomNumberGenerator &rng,
                   Integer const &lo, Integer const &hi);



#endif // __INTUTILS_H

