// testgmp.cc
// tiny test of linking with GMP from C++ code
// this code is from http://www.swox.com/gmp/manual/gmp_4.html#SEC10
                                      
#include <stdio.h>    // stdout
#include "gmp.h"      // GMP functions

void
myfunction (mpz_t result, mpz_t param, unsigned long n)
{
  unsigned long  i;

  mpz_mul_ui (result, param, n);
  for (i = 1; i < n; i++)
    mpz_add_ui (result, result, i*7);
}

// openbsd's g++ lets main get mangled?
//extern "C" int main(void);

int
main (void)
{
  mpz_t  r, n;
  mpz_init (r);
  mpz_init_set_str (n, "123456", 0);

  myfunction (r, n, 20L);
  mpz_out_str (stdout, 10, r); printf ("\n");

  return 0;
}

